import java.util.Vector;

public class LeastSquares{

    int MAXN = 1000;
    int n = 0;
    double beta1, beta0;
    double norm;
    int converged=0;

    Vector<Double> x=new Vector<Double>();
    Vector<Double> y=new Vector<Double>();

    public LeastSquares(double norm){
	this.norm=norm;
    }

    public void addx(double d){
	this.x.addElement(d);
    }


    public void addy(double d){
	this.y.addElement(d);
    }

    public void printall(){
	for (int i=0;i<x.size();i++)
	    System.out.println(x.elementAt(i)+"\t"+y.elementAt(i));
    }

    public void setConverged(boolean b){
	if (b) converged+=1;
	else converged=0;
    }

    public boolean getConverged(){
	System.out.println("conv "+converged);
	return (converged>=2);
    }

    public void compute(){
	double sumx=0,sumx2=0,sumy=0;
	int i;
	int l=(int)((double)(x.size())/2.);
        for (i=l;i<x.size();i++) {
	    sumx  += x.elementAt(i);
	    sumx2 += x.elementAt(i)*x.elementAt(i);
	    sumy  += y.elementAt(i);	    
	}
	
	double xbar = sumx / (x.size()-l);
	double ybar = sumy / (x.size()-l);
    
	// second pass: compute summary statistics
	double xxbar = 0.0, yybar = 0.0, xybar = 0.0;
	for (i = l; i < x.size(); i++) {
	    xxbar += (x.elementAt(i) - xbar) * (x.elementAt(i) - xbar);
	    yybar += (y.elementAt(i) - ybar) * (y.elementAt(i) - ybar);
	    xybar += (x.elementAt(i) - xbar) * (y.elementAt(i) - ybar);
	}
	beta1 = xybar / xxbar;
	beta0 = ybar - beta1 * xbar;
    }

    public double[] getCoeffs(){
	double[] ret=new double[2];
	if (x.lastElement()==0.0 || x.lastElement()==Double.NaN) {
	    ret[0]=0.0;
	    ret[1]=0.0;
	}
	else{
	    ret[0]=beta0/norm;
	    ret[1]=beta1;
	}
	return ret;
    }
}