import java.util.Vector;
// a phage population on a given lattice site
public class Phage {
    int populationStatus;
    double waitingTime;
    double creationTime;
    int maxPopulationStatus;
    int rna;
    int Nneighbors;
    int2D[] neighbors;
    int phageID;
    Host[] neighborHosts;
    boolean slumber=false;
    boolean newPhage;
    int age=0;
    Timestamp ts;
    BinarySearchTree t;
    double expression=-1.0;
    double burstsize=4;
    
    public Phage(){
    }


    public void init(int x, int y, double creationTime, double waitingTime, int phageID,Bacteria b, int Nneighbors, int2D[] neighbors, Host[] neighborHosts, BinarySearchTree t, double expLev){//init the phage population with some initial density     
    System.out.println("error");
    }


    public void init(int x, int y, double creationTime, double waitingTime, int phageID,Bacteria b, int Nneighbors, int2D[] neighbors, Host[] neighborHosts, BinarySearchTree t){//init the phage population with some initial density        
	
	this.t=t;
	this.waitingTime=waitingTime;
	this.ts=new Timestamp(x,y,getUpdateTime(creationTime),phageID);
	t.insert(ts); // the new timestamp is inserted into the search tree
	this.creationTime=creationTime;
	this.phageID=phageID;
	this.maxPopulationStatus=1;
	this.neighbors=neighbors;
	this.Nneighbors=Nneighbors;
	this.neighborHosts=neighborHosts;
	this.rna=phageID-100;
	this.populationStatus=1;
	this.newPhage=true;
	this.age+=1;
	grow(b);
    }


    public void init(int x, int y, double creationTime, double waitingTime, int phageID,Bacteria b, int Nneighbors, int2D[] neighbors, Host[] neighborHosts, BinarySearchTree t, makeAverage phagExp, makeAverage phagAdd){//init the phage population with some initial density        
	System.out.println("error");
    }	

    // a phage that can vary its burst size
    public void init(int x, int y, double creationTime, double waitingTime, int phageID,Bacteria b, int Nneighbors, int2D[] neighbors, Host[] neighborHosts, BinarySearchTree t, makeAverage phagExp, makeAverage phagAdd,boolean burstMutePhage,double bs,double muteRate){//init the phage population with some initial density        
    }
		    
    public void printInfo(){
	System.out.println("phage ID: " + phageID + "\n  rna: " + rna);
    }

    public void grow(Bacteria b){
	int bactPop;
	this.age+=1;
	if (b!=null){
	    bactPop=b.populationStatus;	   
	    if (!b.expressImmunity(rna)){
		if (bactPop>0) { slumber=true;}
		else {this.populationStatus=0; t.remove(ts); slumber=false;}
		b.decrease(rna);		
	    }
	    else {
		this.populationStatus=0;
		t.remove(ts);
	    }
	}
	else if (this.populationStatus>0 && this.newPhage==false) {
	    this.populationStatus-=1;
	    if (this.populationStatus==0) t.remove(ts);
	}
	this.newPhage=false;
    }

    public void setNeighbors(Host[] h){
	this.neighborHosts=h;
    }

	  
    public void update(Bacteria b, double time){
	Timestamp currentTS=this.ts;
	//	System.out.println("updating");
	t.removeMin();
	currentTS.t=getUpdateTime(time);
	t.insert(currentTS);	

	this.age+=1;
	if (slumber){
	    if (this.populationStatus<this.maxPopulationStatus) {
		this.populationStatus+=1;
	    }
	    else {
		t.remove(currentTS);
		this.populationStatus=0;
		spread(time);		
	    }
	}
	else {
	    grow(b);
	}
    }
   
    public double getUpdateTime(double currentT){	
	//System.out.println("Wt "+waitingTime);
	return currentT-waitingTime*Math.log(Math.random());
    }
    
    void spread(double time){ // spread to neighboring sites
	//	System.out.println("age = " + age);
	for (int i=0;i<Nneighbors;i++){
	    slumber=false;	    	    
	    neighborHosts[i].addPhage(time, waitingTime, this.phageID, t);	    	    
	}
    }
}
