import java.util.Vector;
// a phage population on a given lattice site
public class PhageCountExpBurst extends Phage {
    makeAverage phagExp,phagAdd;
    
    boolean burstMutePhage;
    int bs;
    double muteRate;

    public void init(int x, int y, double creationTime, double waitingTime, int phageID,Bacteria b, int Nneighbors, int2D[] neighbors, Host[] neighborHosts, BinarySearchTree t, makeAverage phagExp, makeAverage phagAdd,boolean burstMutePhage,double bs,double muteRate){//init the phage population with some initial density        
	
	//System.out.println("init phage ");
	this.t=t;
	this.waitingTime=waitingTime;
	this.ts=new Timestamp(x,y,getUpdateTime(creationTime),phageID);
	t.insert(ts); // the new timestamp is inserted into the search tree
	this.creationTime=creationTime;
	this.phageID=phageID;
	this.maxPopulationStatus=1;
	this.neighbors=neighbors;
	this.Nneighbors=Nneighbors;
	this.neighborHosts=neighborHosts;
	this.rna=phageID-100;
	this.populationStatus=1;
	this.newPhage=true;
	this.age+=1;
	this.phagExp=phagExp;
	this.phagAdd=phagAdd;
	this.burstMutePhage=burstMutePhage;
	if (burstMutePhage){	   
	    this.burstsize=bs;
	    this.muteRate=muteRate;
	    double ran=Math.random();
	    if (ran<muteRate) {
		if (ran<muteRate/2.) this.burstsize-=1;
		else this.burstsize+=1;
		if (this.burstsize>4) this.burstsize=4;
		if (this.burstsize<0) this.burstsize=0;
	    }
	}
	else
	    this.burstsize=b.burstsize; // the phage acquires the burst size set by the host bacterium
	//System.out.println("burst size "+this.burstsize);
	grow(b);
	//	System.out.println("phage waiting time "+this.waitingTime);
    }




    public void grow(Bacteria b){
	//System.out.println("growing ");
	int bactPop;
	this.age+=1;
	if (b!=null){
	    bactPop=b.populationStatus;	   
	    if (!b.expressImmunity(rna)){
		this.phagExp.addElement(1.);
		if (bactPop>0) { slumber=true;}
		else {this.populationStatus=0; t.remove(ts); slumber=false;}
		b.decrease(rna);		
	    }
	    else {
		this.phagExp.addElement(0.);
		this.populationStatus=0;
		t.remove(ts);
	    }
	}
	else if (this.populationStatus>0 && this.newPhage==false) {
	    this.populationStatus-=1;
	    if (this.populationStatus==0) t.remove(ts);
	}
	this.newPhage=false;
    }

    void spread(double time){ // spread to neighboring sites
	for (int i=0;i<Nneighbors;i++){
	    slumber=false;	
	    // System.out.println("Pspread ");
	    //neighborHosts[i].addPhageCountExp(time, waitingTime, this.phageID, t, phagExp,phagAdd); 
	    if (Math.random()<this.burstsize) neighborHosts[i].addPhageCountExpBurst(time, waitingTime, this.phageID, t, phagExp,phagAdd,this.burstMutePhage,this.burstsize,this.muteRate); 
	}
    }

    /*    void spread(double time){ // spread to neighboring sites
	Vector<Integer> avail=new Vector<Integer>();
	int toInfect=0;
	int in=0;
	for (int j=0;j<this.Nneighbors;j++) avail.add(j);
	for (int i=0;i<this.burstsize;i++){
	    in=(int)(Math.random()*avail.size());
	    toInfect=avail.elementAt(in);
	    avail.removeElementAt(in);
	    slumber=false;	
	    // System.out.println("Pspread ");
	    neighborHosts[toInfect].addPhageCountExpBurst(time, waitingTime, this.phageID, t, phagExp,phagAdd,this.burstMutePhage,this.burstsize,this.muteRate); 
	}
    }
    */
}
