import java.io.*;  
import java.util.Vector;


public class outputWriter{
    String filename;
    boolean noData, writeHeader;
    
    public outputWriter(String filename, boolean writeHeader){
	this.filename=filename;
	this.writeHeader=writeHeader;
	this.noData=true;
	try {
	    FileWriter outFile = new FileWriter(filename,false);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }
    

    public void insertLine(int n){	
	
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    for (int i=0;i<n;i++)
		out.print("\n");
		
		
		out.close();
	} catch (IOException e){
		e.printStackTrace();
	}
	    
    }

    public void insertComment(String s){	
	
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	   
		out.print(s+"\n");
		
		
		out.close();
	} catch (IOException e){
		e.printStackTrace();
	}
	    
    }
  
    public void outputToFile(double[] pars, makeAverage a[], int length_a, makeAverage b[], int length_b,double norm){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    if (noData && writeHeader){
		out.print("#");
		
		if (pars!=null) for (int i=0;i<pars.length;i++)    out.print("\t");
		for (int i=0;i<length_a;i++)       out.print(a[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(b[i].getName()+ "\t");
		out.print("\n");
		noData=false;
	    }
	    
	    // Write text to file
	    for (int i=0;i<pars.length;i++)    out.print(((double)((double)((int)(10000.*pars[i])))/10000.)+"\t");
	    for (int i=0;i<length_a;i++)       out.print(""+((double)((double)((int)(100000.*(a[i].getOldAverage())/norm)))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(b[i].getOldAverage())/norm)))/100000.)+ "\t");
	    out.print("\n");
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }

    public void outputToFileIntMatrix2D(int[][] m, int nx, int ny, int norm){
		    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    if (noData && writeHeader){
		//out.print("#");
		
		for (int i=0;i<nx;i++) {
		    for (int j=0;j<ny;j++)
			out.print(((double)((double)((int)(100000.*(double)(m[i][j])/(double)norm)))/100000.)+"\t");
		    //out.print(m[i][j]+ "\t");	       
		    out.print("\n");
		}
		noData=false;
	    }	    	   
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


    public void outputToFileINTMatrix2D(int[][] m, int nx, int ny){
		    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    
		//out.print("#");
		
		for (int i=0;i<nx;i++) {
		    for (int j=0;j<ny;j++)
			out.print(m[i][j]+"\t");
		    out.print("\n");
		}
	
	    
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }

/*
    public void outputToFileScatterVector(Vector<Bacterium> i1){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2).x+"\t"+i1.elementAt(j2).y+"\t"+i1.elementAt(j2).historyLength()+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }

*/

    public void outputToFileDoubleMatrix2D(int[] v, double[][] m, int nx, int ny, double norm){
		    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    if (noData && writeHeader){
		//out.print("#");
		
		for (int i=0;i<nx;i++) {
		    out.print(v[i]+"\t");
		    for (int j=0;j<ny;j++)
			out.print(((double)((double)((int)(100000.*(double)(m[i][j])/(double)norm)))/100000.)+"\t");
		    //out.print(m[i][j]+ "\t");	       
		    out.print("\n");
		}
		noData=false;
	    }	    	   
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


    public void outputToFile(double[] pars, makeAverage phagExp[], makeAverage phagAdd[], makeAverage a[], int length_a, makeAverage b[], int length_b,double norm){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    if (noData && writeHeader){
		out.print("#");
		
		if (pars!=null) for (int i=0;i<pars.length;i++)    out.print("\t");
		for (int i=0;i<length_b;i++)       out.print(phagExp[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(phagAdd[i].getName()+ "\t");
		for (int i=0;i<length_a;i++)       out.print(a[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(b[i].getName()+ "\t");
		out.print("\n");
		noData=false;
	    }
	    
	    // Write text to file
	    for (int i=0;i<pars.length;i++)    out.print(((double)((double)((int)(10000.*pars[i])))/10000.)+"\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(phagExp[i].getOldAverage()))))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(phagAdd[i].getOldAverage()))))/100000.)+ "\t");
	    for (int i=0;i<length_a;i++)       out.print(""+((double)((double)((int)(100000.*(a[i].getOldAverage())/norm)))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(b[i].getOldAverage())/norm)))/100000.)+ "\t");
	    out.print("\n");
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }



    public void outputToFile(double pars[],Histogram d1, makeAverage a[], int length_a, makeAverage b[], int length_b,double norm){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	 
	    if (noData && writeHeader){
		out.print("#");		
		if (pars!=null) for (int i=0;i<pars.length;i++)    out.print("\t");		
		out.print(d1.name+"\t");
		for (int i=0;i<length_a;i++)       out.print(a[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(b[i].getName()+ "\t");
		out.print("\n");
		noData=false;
	    }
	    
	 
	    // Write text to file
	    for (int i=0;i<pars.length;i++)    out.print(((double)((double)((int)(10000.*pars[i])))/10000.)+"\t");
	    out.print(((double)((double)((int)(10000.*d1.mean)))/10000.)+"\t");
	    for (int i=0;i<length_a;i++)       out.print(""+((double)((double)((int)(100000.*(a[i].getOldAverage())/norm)))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(b[i].getOldAverage())/norm)))/100000.)+ "\t");
	    out.print("\n");
	  
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
	
    }



    public void outputToFile(Histogram d1, Histogram d2, makeAverage a[], int length_a, makeAverage b[], int length_b,double norm){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    

	    if (noData && writeHeader){
		out.print("#");				
		out.print(d1.name+"\t");
		out.print(d2.name+"\t");		
		for (int i=0;i<length_a;i++)       out.print(a[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(b[i].getName()+ "\t");
		out.print("\n");
		noData=false;
	    }
	    
	    	    
	    // Write text to file
	    out.print(((double)((double)((int)(10000.*d1.mean)))/10000.)+"\t" + ((double)((double)((int)(10000.*d2.mean)))/10000.)+"\t");
	    for (int i=0;i<length_a;i++)       out.print(""+((double)((double)((int)(100000.*(a[i].getOldAverage())/norm)))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(b[i].getOldAverage())/norm)))/100000.)+ "\t");
	    out.print("\n");
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


    public void outputToFile(double pars[],Histogram[] d1, makeAverage a[], int length_a, makeAverage b[], int length_b,double norm){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	 
	    if (noData && writeHeader){
		out.print("#");		
		if (pars!=null) for (int i=0;i<pars.length;i++)    out.print("\t");		
	        for (int h=0;h<d1.length;h++) out.print(d1[h].name+"\t");
		for (int i=0;i<length_a;i++)       out.print(a[i].getName()+ "\t");
		for (int i=0;i<length_b;i++)       out.print(b[i].getName()+ "\t");
		out.print("\n");
		noData=false;
	    }
	    
	 
	    // Write text to file
	    for (int i=0;i<pars.length;i++)    out.print(((double)((double)((int)(10000.*pars[i])))/10000.)+"\t");
	    for (int h=0;h<d1.length;h++) out.print(((double)((double)((int)(10000.*d1[h].mean)))/10000.)+"\t");
	    for (int i=0;i<length_a;i++)       out.print(""+((double)((double)((int)(100000.*(a[i].getOldAverage())/norm)))/100000.)+ "\t");
	    for (int i=0;i<length_b;i++)       out.print(""+((double)((double)((int)(100000.*(b[i].getOldAverage())/norm)))/100000.)+ "\t");
	    out.print("\n");
	  
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
	
    }


    public void outputToFileScatter2D(Vector<Double> i1, Vector<Double> i2){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2)+"\t"+i2.elementAt(j2)+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


    public void outputToFileScatter3D(Vector<Double> i1, Vector<Double> i2, Vector<Double> i3){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2)+"\t"+i2.elementAt(j2)+"\t"+i3.elementAt(j2)+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


   public void outputToFileScatter3D(Vector<Double> i1, Vector<Double> i2, Vector<Double> i3, Vector<Double> i4){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2)+"\t"+i2.elementAt(j2)+"\t"+i3.elementAt(j2)+"\t"+i4.elementAt(j2)+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }


    public void outputToFileScatter2DVector(Vector<int2D> i1, Vector<Integer> d){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2).x+"\t"+i1.elementAt(j2).y+"\t"+d.elementAt(j2)+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }




    public void outputToFileScatter4D(Vector<Double> i1, Vector<Double> i2, Vector<Double> i3, Vector<Double> i4){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2)+"\t"+i2.elementAt(j2)+"\t"+i3.elementAt(j2)+"\t"+i4.elementAt(j2)+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }

    public void outputToFileScatter4DFamily(Vector<Double> i1, Vector<Double> i2, Vector<Double> i3, Vector<Double> i4,Vector<Vector<Integer>> i5){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    
	    // Also could be written as follows on one line
	    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
	    
	    // Write text to file
	    for (int j2=0;j2<i1.size();j2++){		    
		out.print(i1.elementAt(j2)+"\t"+i2.elementAt(j2)+"\t"+i3.elementAt(j2)+"\t"+i4.elementAt(j2)+"\t"+i5.elementAt(j2).toString()+"\n");
	    }
	    
	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }

    public void outputToFile(double[] pars, Histogram hist){
	
	    
	try {
	    FileWriter outFile = new FileWriter(filename,true);
	    PrintWriter out = new PrintWriter(outFile);
	    	    
	    if (writeHeader){
		out.print("#");
		for (int i=0;i<pars.length;i++)    out.print(pars[i]+" \t");
		
		out.print("\n");
		
	    }

	    
	    // Write text to file
	    for (int i=0;i<hist.density.length;i++)    out.print(hist.density[i]+"\t"+hist.mids[i]+"\n");
	    out.print("\n\n");
	    	    
	    out.close();
	} catch (IOException e){
	    e.printStackTrace();
	}
    }
}
